/*
 * GUIEditTheory.java
 *
 * Created on 28 settembre 2000, 12.08
 */

package alice.tuprologx.ide;
import java.io.*;
import alice.tuprolog.*;

import javax.swing.JTextArea; // to replace JEditTextArea

import java.util.Vector;

/**
 *
 * @author  Administrator
 * @version
 */
public class EditTheory extends javax.swing.JFrame {

    GUIConsole editor;
	
	//alice.util.jedit.JEditTextArea inputTheory;
	JTextArea inputTheory;

    /** Creates new form GUIEditTheory */
    public EditTheory(GUIConsole edit) {
        initComponents ();

		/*
        inputTheory= new alice.util.jedit.JEditTextArea(new PrologTextArea());
        inputTheory.setTokenMarker(new PrologTokenMarker());
		*/
		inputTheory = new JTextArea();
        inputTheory.setPreferredSize (new java.awt.Dimension(560, 600));
		inputTheory.setFont(new java.awt.Font("Courier", 0 , 12));
        java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 100.0;
        gridBagConstraints1.weighty = 95.0;
        getContentPane ().add (inputTheory, gridBagConstraints1);

        inputTheory.getDocument().addDocumentListener(new javax.swing.event.DocumentListener() {
            public void changedUpdate(javax.swing.event.DocumentEvent evt) {
                stateBar.setText("");
            }
            public void insertUpdate(javax.swing.event.DocumentEvent evt) {
                stateBar.setText("");
            }
            public void removeUpdate(javax.swing.event.DocumentEvent evt) {
                stateBar.setText("");
            }
        }
        );
		
        inputTheory.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                // caretPosition.setText("line "+(inputTheory.getCaretLine()+1)+"   ");
				caretPosition.setText("line " + getCurrentLine(inputTheory.getCaretPosition()) + " ");
            }
        }
        );
		
        pack ();
        editor=edit;
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
	
	/**
	 * Given the caret position in in the <code>TextArea</code>, return the
	 * line in the text where the caret is positioned.
     *
	 * @param caretPosition The position of the caret in the text.
	 * @return The line in the text where the caret is positioned.
	 */
	private int getCurrentLine(int caretPosition) {
		Vector table = buildLengthTable(inputTheory.getText());
		int textLength = ((Integer) table.get(table.size() - 1)).intValue();

		for (int index = 0; index < table.size(); index++) {
			int highBound = ((Integer) table.get(index)).intValue();
			if (caretPosition < highBound)
				return index + 1;
		}
		// return the correct line number if the caret is at the end of the whole text
		return table.size();
	}
	
	/**
	 * Build a table containing for each line the partial length of the text
	 * from the beginning to the current line.
     *
	 * @param text The text to analyze.
	 * @return The table as <code>java.util.Vector</code>.
	 */
	private Vector buildLengthTable(String text) {
		Vector table = new Vector();
		int lines = 0;
		int textLength = 0;
		String remaining = text;

		while (remaining.indexOf("\n") != -1) {
			int lineLength = remaining.substring(0, remaining.indexOf("\n")).length();
			if (lineLength == 0)
				textLength++;
			else
				textLength += lineLength + 1; // count the newline
			table.add(lines++, new Integer(textLength));
			remaining = remaining.substring(remaining.indexOf("\n") + 1);
		}
		// add the last line (the one not containing a newline)
		textLength += remaining.length();
		table.add(lines, new Integer(textLength));

		return table;
	}

    public void setTheoryText(String st){
        inputTheory.setText(st);
    }

    public String getTheoryText(){
        return inputTheory.getText();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        bOk = new javax.swing.JButton();
        caretPosition = new javax.swing.JTextField();
        bRestore = new javax.swing.JButton();
        stateBar = new javax.swing.JTextField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("Edit theory");
        setFont(new java.awt.Font("Arial", 0, 10));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                onWindowsClosing(evt);
            }
        });

        bOk.setFont(new java.awt.Font("Arial", 0, 11));
        bOk.setText("Set Theory");
        bOk.setToolTipText("accept theory");
        bOk.setBorder(new javax.swing.border.EtchedBorder());
        bOk.setMaximumSize(new java.awt.Dimension(90, 30));
        bOk.setMinimumSize(new java.awt.Dimension(90, 30));
        bOk.setPreferredSize(new java.awt.Dimension(90, 30));
        bOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOkActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 5.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(bOk, gridBagConstraints);

        caretPosition.setBackground(new java.awt.Color(204, 204, 255));
        caretPosition.setEditable(false);
        caretPosition.setBorder(new javax.swing.border.CompoundBorder(null, new javax.swing.border.LineBorder(new java.awt.Color(153, 153, 153))));
        caretPosition.setMinimumSize(new java.awt.Dimension(100, 20));
        caretPosition.setPreferredSize(new java.awt.Dimension(100, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        getContentPane().add(caretPosition, gridBagConstraints);

        bRestore.setFont(new java.awt.Font("Arial", 0, 11));
        bRestore.setText("Restore Theory");
        bRestore.setToolTipText("accept theory");
        bRestore.setBorder(new javax.swing.border.EtchedBorder());
        bRestore.setMaximumSize(new java.awt.Dimension(90, 30));
        bRestore.setMinimumSize(new java.awt.Dimension(90, 30));
        bRestore.setPreferredSize(new java.awt.Dimension(90, 30));
        bRestore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bRestoreActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 5.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(bRestore, gridBagConstraints);

        stateBar.setBackground(new java.awt.Color(204, 204, 255));
        stateBar.setEditable(false);
        stateBar.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        stateBar.setMinimumSize(new java.awt.Dimension(4, 25));
        stateBar.setPreferredSize(new java.awt.Dimension(63, 25));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(stateBar, gridBagConstraints);

    }//GEN-END:initComponents

    private void bRestoreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bRestoreActionPerformed
    try {
        inputTheory.setText(editor.engine.getTheory().toString());
        editor.setOutputState("Theory restored.");
        stateBar.setText("Restore Theory OK.");
        //this.dispose();
        //editor.enableGoalCmds(true);
        //editor.enableTheoryCmds(true);
    } catch (Exception ex){
        ex.printStackTrace();
        editor.setOutputState("Unable to restore theory.");
        stateBar.setText("Restore Theory Failed.");
    }
    }//GEN-LAST:event_bRestoreActionPerformed

  private void inputTheoryCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_inputTheoryCaretUpdate
  }//GEN-LAST:event_inputTheoryCaretUpdate

  private void bOkActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOkActionPerformed
    // Add your handling code here:
    try {
        Theory th=new Theory(inputTheory.getText());
        editor.engine.setTheory(th);
        editor.setOutputState("New theory accepted.");
        stateBar.setText("Set Theory OK.");

        //this.dispose();
        //editor.enableGoalCmds(true);
        //editor.enableTheoryCmds(true);
    } catch (InvalidTheoryException ex){
        //ex.printStackTrace();
        editor.setOutputState("Error setting theory at/before line "+ex.line+".");
        stateBar.setText("Syntax Error at/before line "+ex.line+".");
    } catch (Exception ex){
        ex.printStackTrace();
        editor.setOutputState("Set Theory Failed: Generic Failure.");
        stateBar.setText("Set Theory Failed: Generic Failure.");
    }
  }//GEN-LAST:event_bOkActionPerformed

  private void onWindowsClosing (java.awt.event.WindowEvent evt) {//GEN-FIRST:event_onWindowsClosing
    // Add your handling code here:
    CloseDialog cd=new CloseDialog(new javax.swing.JFrame(), true);
    cd.show();
    boolean closeOk=true;
    if (cd.isTheoryToSet()){
        try {
            Theory th=new Theory(inputTheory.getText());
            editor.engine.setTheory(th);
            editor.setOutputState("New Theory Accepted.");
        } catch (InvalidTheoryException ex){
            editor.setOutputState("Error setting theory at/before line "+ex.line+".");
            closeOk=false;
        } catch (Exception ex){
            editor.setOutputState("Set Theory Failed: Generic Failure.");
            closeOk=false;
        }
    }
    if (closeOk){
        editor.enableGoalCmds(true);
        editor.enableTheoryCmds(true);
        editor.setOutputState("Ready.");
        dispose();
    }

  }//GEN-LAST:event_onWindowsClosing

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bOk;
    private javax.swing.JButton bRestore;
    private javax.swing.JTextField caretPosition;
    private javax.swing.JTextField stateBar;
    // End of variables declaration//GEN-END:variables

}
