package alice.tuprologx.ide;

import javax.swing.*;
import java.io.*;
import java.util.*;
import  alice.tuprolog.*;

public class GUIConsole extends javax.swing.JFrame implements Serializable, OutputListener, SpyListener, StateListener {

    public Prolog engine;
    SolveInfo info;

    SpyArea     spyAreaForm;
    EditTheory  editTheoryForm;
    OutputArea  outputArea;
    About       aboutArea;

    String      engineName;
    int         port;
    String      portString;
    String      hostName;

    String theoryFileName="default.pl";
    ArrayList history=new ArrayList();
    int historyIndex=0;

    public GUIConsole(String[] args) {
        System.out.println("tuProlog system - release "+Prolog.getVersion());
        initComponents ();
        pack ();
        setSize(400,300);
        spyAreaForm=new SpyArea();
        aboutArea=new About();
        editTheoryForm=new EditTheory(this);
        outputArea=new OutputArea();
        engine=new Prolog();
        engine.addStateListener(this);
        engine.addSpyListener(this);
        engine.addOutputListener(this);
        enableSolutionCmds(false);
        outputState.setText("Ready.");
    }

    public void enableTheoryCmds(boolean flag){
        loadTheory.setEnabled(flag);
        saveTheory.setEnabled(flag);
        saveTheoryAs.setEnabled(flag);
        newTheory.setEnabled(flag);
        editTheory.setEnabled(flag);
    }

    public void enableSolutionCmds(boolean flag){
        bYes.setEnabled(flag);
        bNext.setEnabled(flag);
    }

    public void enableGoalCmds(boolean flag){
        inputGoal.setEnabled(flag);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        solvePanel = new javax.swing.JPanel();
        queryPanel = new javax.swing.JPanel();
        solveLabel = new javax.swing.JLabel();
        inputGoal = new javax.swing.JTextField();
        answerPanel = new javax.swing.JPanel();
        outputScrollPane = new javax.swing.JScrollPane();
        outputSolution = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        commandPanel = new javax.swing.JPanel();
        bNext = new javax.swing.JButton();
        bYes = new javax.swing.JButton();
        outputState = new javax.swing.JTextField();
        jMenuBar1 = new javax.swing.JMenuBar();
        file = new javax.swing.JMenu();
        newTheory = new javax.swing.JMenuItem();
        loadTheory = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        saveTheory = new javax.swing.JMenuItem();
        saveTheoryAs = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        exit = new javax.swing.JMenuItem();
        edit = new javax.swing.JMenu();
        editTheory = new javax.swing.JMenuItem();
        view = new javax.swing.JMenu();
        outputView = new javax.swing.JMenuItem();
        spyView = new javax.swing.JMenuItem();
        help = new javax.swing.JMenu();
        about = new javax.swing.JMenuItem();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("tuProlog IDE");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        solvePanel.setLayout(new java.awt.GridBagLayout());

        solvePanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)));
        queryPanel.setLayout(new java.awt.GridBagLayout());

        queryPanel.setBorder(new javax.swing.border.TitledBorder(null, "Query", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Verdana", 0, 10)));
        solveLabel.setFont(new java.awt.Font("Arial", 0, 11));
        solveLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        solveLabel.setText("?-");
        solveLabel.setMaximumSize(new java.awt.Dimension(20, 15));
        solveLabel.setMinimumSize(new java.awt.Dimension(20, 15));
        solveLabel.setPreferredSize(new java.awt.Dimension(20, 30));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        queryPanel.add(solveLabel, gridBagConstraints);

        // inputGoal.setFont(new java.awt.Font("Courier New", 0, 12));
		inputGoal.setFont(new java.awt.Font("Courier", 0, 12));
        inputGoal.setMinimumSize(new java.awt.Dimension(22, 22));
        inputGoal.setPreferredSize(new java.awt.Dimension(100, 22));
        inputGoal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inputGoalActionPerformed(evt);
            }
        });

        inputGoal.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                inputGoalKeyReleased(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 20);
        queryPanel.add(inputGoal, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        solvePanel.add(queryPanel, gridBagConstraints);

        answerPanel.setLayout(new java.awt.GridBagLayout());

        answerPanel.setBorder(new javax.swing.border.TitledBorder(null, "Answer", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Verdana", 0, 10)));
        outputScrollPane.setMinimumSize(new java.awt.Dimension(22, 80));
        outputScrollPane.setPreferredSize(new java.awt.Dimension(100, 80));
        outputSolution.setEditable(false);
        // outputSolution.setFont(new java.awt.Font("Courier New", 0, 12));
		outputSolution.setFont(new java.awt.Font("Courier", 0, 12));
        outputScrollPane.setViewportView(outputSolution);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 100.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 20);
        answerPanel.add(outputScrollPane, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setMaximumSize(new java.awt.Dimension(20, 15));
        jLabel1.setMinimumSize(new java.awt.Dimension(20, 15));
        jLabel1.setPreferredSize(new java.awt.Dimension(20, 30));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        answerPanel.add(jLabel1, gridBagConstraints);

        commandPanel.setLayout(new java.awt.GridBagLayout());

        bNext.setFont(new java.awt.Font("Arial", 0, 10));
        bNext.setText("Next");
        bNext.setPreferredSize(new java.awt.Dimension(70, 27));
        bNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bNextActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        commandPanel.add(bNext, gridBagConstraints);

        bYes.setFont(new java.awt.Font("Arial", 0, 10));
        bYes.setText("Accept");
        bYes.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        bYes.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        bYes.setPreferredSize(new java.awt.Dimension(70, 27));
        bYes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bYesActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        commandPanel.add(bYes, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        answerPanel.add(commandPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 100.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        solvePanel.add(answerPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 50.0;
        getContentPane().add(solvePanel, gridBagConstraints);

        outputState.setBackground(java.awt.Color.lightGray);
        outputState.setEditable(false);
        outputState.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        outputState.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                outputStateActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 100.0;
        getContentPane().add(outputState, gridBagConstraints);

        file.setText("File");
        newTheory.setFont(new java.awt.Font("Arial", 0, 11));
        newTheory.setText("New theory");
        newTheory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newTheoryActionPerformed(evt);
            }
        });

        file.add(newTheory);
        loadTheory.setFont(new java.awt.Font("Arial", 0, 11));
        loadTheory.setText("Load theory");
        loadTheory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadTheoryActionPerformed(evt);
            }
        });

        file.add(loadTheory);
        file.add(jSeparator1);
        saveTheory.setFont(new java.awt.Font("Arial", 0, 11));
        saveTheory.setText("Save theory");
        saveTheory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveTheoryActionPerformed(evt);
            }
        });

        file.add(saveTheory);
        saveTheoryAs.setFont(new java.awt.Font("Arial", 0, 11));
        saveTheoryAs.setText("Save theory As");
        saveTheoryAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveTheoryAsActionPerformed(evt);
            }
        });

        file.add(saveTheoryAs);
        file.add(jSeparator2);
        exit.setFont(new java.awt.Font("Arial", 0, 11));
        exit.setText("Exit");
        exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitActionPerformed(evt);
            }
        });

        file.add(exit);
        jMenuBar1.add(file);
        edit.setText("Edit");
        editTheory.setFont(new java.awt.Font("Arial", 0, 11));
        editTheory.setText("Edit theory");
        editTheory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editTheoryActionPerformed(evt);
            }
        });

        edit.add(editTheory);
        jMenuBar1.add(edit);
        view.setText("View");
        outputView.setFont(new java.awt.Font("Arial", 0, 11));
        outputView.setText("View Output");
        outputView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                outputViewActionPerformed(evt);
            }
        });

        view.add(outputView);
        spyView.setFont(new java.awt.Font("Arial", 0, 11));
        spyView.setText("View Spy Information");
        spyView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                spyViewActionPerformed(evt);
            }
        });

        view.add(spyView);
        jMenuBar1.add(view);
        help.setText("Help");
        about.setFont(new java.awt.Font("Arial", 0, 11));
        about.setText("About");
        about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutActionPerformed(evt);
            }
        });

        help.add(about);
        jMenuBar1.add(help);
        setJMenuBar(jMenuBar1);

    }//GEN-END:initComponents

  private void aboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutActionPerformed
        aboutArea.show();
  }//GEN-LAST:event_aboutActionPerformed

  private void exitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitActionPerformed
        exitForm(null);
  }//GEN-LAST:event_exitActionPerformed

  private void spyViewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_spyViewActionPerformed
        spyAreaForm.show ();
  }//GEN-LAST:event_spyViewActionPerformed

  private void outputViewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_outputViewActionPerformed
        outputArea.show();
  }//GEN-LAST:event_outputViewActionPerformed

  private void editTheoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editTheoryActionPerformed
      // Add your handling code here:
      ByteArrayOutputStream bout=new ByteArrayOutputStream();
      try {
          Theory th=engine.getTheory();
          bout.write(th.toString().getBytes());
          editTheoryForm.setTheoryText(new String(bout.toByteArray()));
          editTheoryForm.show();
          outputState.setText("Theory Editor opened");
          //enableGoalCmds(false);
          //enableTheoryCmds(false);
      } catch (Exception ex){
      }
  }//GEN-LAST:event_editTheoryActionPerformed

  private void saveTheoryAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveTheoryAsActionPerformed
      try {
          JFileChooser chooser = new JFileChooser();
          outputState.setText("Save Theory As ...");
          int returnVal = chooser.showOpenDialog(this);
          if(returnVal == JFileChooser.APPROVE_OPTION) {
              theoryFileName=chooser.getCurrentDirectory()+"/"+chooser.getSelectedFile().getName();
              new FileOutputStream(theoryFileName).write(engine.getTheory().toString().getBytes());
              outputState.setText("Save Theory to "+theoryFileName+" ok.");
          }
      } catch (Exception ex){
          outputState.setText("Error saving theory to "+theoryFileName);
      }
  }//GEN-LAST:event_saveTheoryAsActionPerformed

  private void saveTheoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveTheoryActionPerformed
      try {
          new FileOutputStream(theoryFileName).write(engine.getTheory().toString().getBytes());
          outputState.setText("Save Theory to "+theoryFileName+" ok.");
      } catch (Exception ex){
          outputState.setText("Error saving theory to "+theoryFileName);
      }
  }//GEN-LAST:event_saveTheoryActionPerformed

  private void loadTheoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadTheoryActionPerformed
      // Add your handling code here:
      try {
          JFileChooser chooser = new JFileChooser();
          outputState.setText("Load Theory");
          int returnVal = chooser.showOpenDialog(this);
          if(returnVal == JFileChooser.APPROVE_OPTION) {
              Theory th=new Theory(new FileInputStream(chooser.getCurrentDirectory()+"/"+chooser.getSelectedFile().getName()));
              engine.addTheory(th);
              outputState.setText("Ready (consult theory ok).");
          } else {
              outputState.setText("Ready.");
          }
      } catch (Exception ex){
          outputState.setText("Error consulting theory.");
      }
  }//GEN-LAST:event_loadTheoryActionPerformed

  private void newTheoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newTheoryActionPerformed
      // Add your handling code here:
      engine.clearTheory();
      outputState.setText("Ready (new theory ok).");
  }//GEN-LAST:event_newTheoryActionPerformed

  private void inputGoalKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputGoalKeyReleased
      int code=evt.getKeyCode();
      // code 38: up arrow
      // code 38: down arrow
      if (code==38){
          // prev in history
          if (historyIndex>0){
              historyIndex--;
          }
          if (historyIndex<history.size()){
              HistoryInfo info=(HistoryInfo)history.get(historyIndex);
              inputGoal.setText(info.goal);
              outputSolution.setText(info.substitution+"\n"+info.solution);
              outputScrollPane.getHorizontalScrollBar().setValue(0);
          } else {
              inputGoal.setText("");
              outputSolution.setText("");
          }
      } else if (code==40){
          // next in history
          if (historyIndex<history.size()){
              historyIndex++;
          }
          if (historyIndex<history.size()){
              HistoryInfo info=(HistoryInfo)history.get(historyIndex);
              inputGoal.setText(info.goal);
              outputSolution.setText(info.substitution+"\n"+info.solution);
              outputScrollPane.getHorizontalScrollBar().setValue(0);
          } else {
              inputGoal.setText("");
              outputSolution.setText("");
          }
      }
  }//GEN-LAST:event_inputGoalKeyReleased

  private void bUpActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bUpActionPerformed
        }//GEN-LAST:event_bUpActionPerformed

  private void bDownActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDownActionPerformed
        }//GEN-LAST:event_bDownActionPerformed

  private void bSolveActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSolveActionPerformed
      // Add your handling code here:
      inputGoalActionPerformed(null);
  }//GEN-LAST:event_bSolveActionPerformed

  private void bNextActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bNextActionPerformed
      // Add your handling code here:
      try {
          outputState.setText("solving...");
          info=engine.solveNext();
          if (info.isHalt()){
              exitForm(null);
          } else
              if (!info.isSuccess()){
                  outputSolution.setText("no.");
                  updateSlot(inputGoal.getText(),"no.","");
                  enableSolutionCmds(false);
                  enableGoalCmds(true);
                  enableTheoryCmds(true);
                  outputState.setText("Ready.");
              } else {
                  outputState.setText("Found another solution (open alternatives can be explored).");
                  String binds=toString(info.getSubstitution());
                  outputSolution.setText(binds+engine.toString(info.getSolution())+" ?");
              }
      } catch (NoMoreSolutionException ex){
          outputSolution.setText("no.");
          outputState.setText("Ready.");
          updateSlot(inputGoal.getText(),"no.","");
          enableSolutionCmds(false);
          enableGoalCmds(true);
          enableTheoryCmds(true);
      } catch (Exception ex){
          outputSolution.setText("General Failure.");
          outputState.setText("Ready.");
          enableSolutionCmds(false);
          enableGoalCmds(true);
          enableTheoryCmds(true);
      }
  }//GEN-LAST:event_bNextActionPerformed

  private void bYesActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bYesActionPerformed
      // Add your handling code here:
      try {
          String binds=toString(info.getSubstitution());
          if (binds.equals("")){
              outputSolution.setText("yes.\nSolution: "+engine.toString(info.getSolution()));
          } else{
              outputSolution.setText("yes.\n"+binds+"Solution: "+engine.toString(info.getSolution()));
          }
          outputScrollPane.getHorizontalScrollBar().setValue(0);
          updateSlot(inputGoal.getText(),"Solution: "+engine.toString(info.getSolution()),binds);
          outputState.setText("Ready.");
          enableSolutionCmds(false);
          enableGoalCmds(true);
          enableTheoryCmds(true);
      } catch (Exception ex){
      };
  }//GEN-LAST:event_bYesActionPerformed

  private void inputGoalActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inputGoalActionPerformed
      // Add your handling code here:
      new ProcessInput(this).start();
  }//GEN-LAST:event_inputGoalActionPerformed

  private void updateSlot(String goal,String sol,String sub){
      history.add(new HistoryInfo(goal,sol,sub));
  }

  private void outputStateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_outputStateActionPerformed
      // Add your handling code here:
  }//GEN-LAST:event_outputStateActionPerformed

/** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        spyAreaForm.dispose();
        editTheoryForm.dispose();
        this.dispose();
        System.exit(0);
    }//GEN-LAST:event_exitForm

    public void onOutput(OutputEvent ev) {
        outputArea.appendMsg(ev.getMsg());
    }

    public void onSpy(SpyEvent ev) {
        spyAreaForm.getArea().append(ev.getMsg()+"\n");
    }

    public void onState(StateEvent ev) {
        outputState.setText(ev.getMsg());
    }

    public static void main (String args[]) {
        new GUIConsole(args).show ();
    }

    javax.swing.JTextField getStateArea(){
        return outputState;
    }

    class ProcessInput extends Thread {
        ProcessInput(GUIConsole console){
            this.console=console;
        }
        public void run(){
            String goal=console.inputGoal.getText();
            try {
                console.outputState.setText("solving...");
                info=console.engine.solve(goal);
                if (info.isHalt()){
                    exitForm(null);
                } else
                    if (!info.isSuccess()){
                        console.outputSolution.setText("no.");
                        updateSlot(inputGoal.getText(),"no.","");
                        console.outputState.setText("Ready.");
                    } else
                        if (!engine.hasOpenAlternatives()){
                            String binds=console.toString(info.getSubstitution());
                            if (binds.equals("")){
                                console.outputSolution.setText("yes.\nSolution: "+engine.toString(info.getSolution()));
                            } else {
                                console.outputSolution.setText("yes.\n"+binds+"Solution: "+engine.toString(info.getSolution()));
                            }
                            outputState.setText("Ready.");
                            console.updateSlot(console.inputGoal.getText(),"Solution: "+engine.toString(info.getSolution()),binds);
                            console.outputScrollPane.getHorizontalScrollBar().setValue(0);
                            
                        } else {
                            console.outputState.setText("Found a solution (open alternatives can be explored).");
                            String binds=console.toString(info.getSubstitution());
                            console.outputSolution.setText(binds+engine.toString(info.getSolution())+" ?");
                            console.outputScrollPane.getHorizontalScrollBar().setValue(0);
                            console.enableSolutionCmds(true);
                            console.enableGoalCmds(false);
                            console.enableTheoryCmds(false);
                        }
            } catch (MalformedGoalException ex){
                console.outputSolution.setText("syntax error.");
                console.outputState.setText("Ready.");
            } catch (Exception ex){
                console.outputSolution.setText("generic error. "+ex.toString());
                console.outputState.setText("Ready.");
            }
        }
        GUIConsole console;
    }


    String toString(Substitution sub){
        Var[] vars=sub.toVarArray();
        String st="";
        for (int i=0; i<vars.length; i++)
            if (vars[i]!=null && !vars[i].getName().startsWith("_")){
                st=st+vars[i].getName()+" = "+vars[i].getTerm()+"\n";
            }
        return st;
    }

    public void setOutputState(String msg){
        outputState.setText(msg);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField inputGoal;
    private javax.swing.JMenu file;
    private javax.swing.JPanel commandPanel;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JScrollPane outputScrollPane;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton bNext;
    private javax.swing.JLabel solveLabel;
    private javax.swing.JMenuItem loadTheory;
    private javax.swing.JPanel answerPanel;
    private javax.swing.JButton bYes;
    private javax.swing.JMenu view;
    private javax.swing.JMenuItem newTheory;
    private javax.swing.JMenuItem exit;
    private javax.swing.JPanel queryPanel;
    private javax.swing.JTextArea outputSolution;
    private javax.swing.JMenuItem saveTheoryAs;
    private javax.swing.JTextField outputState;
    private javax.swing.JMenuItem editTheory;
    private javax.swing.JMenuItem about;
    private javax.swing.JMenu edit;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem outputView;
    private javax.swing.JPanel solvePanel;
    private javax.swing.JMenuItem saveTheory;
    private javax.swing.JMenu help;
    private javax.swing.JMenuItem spyView;
    // End of variables declaration//GEN-END:variables

}

class HistoryInfo {
    public String goal;
    public String solution;
    public String substitution;
    public HistoryInfo(String goal, String solution,String sub){
        this.goal=goal;
        this.solution=solution;
        this.substitution=sub;
    }
}


